from lib.controller import *
from lib.display import *
from lib.display_update import  *
from lib.Factory_Variables import *
from lib.Log import *
from lib.MQTT import *
from lib.MQTT_Bridge import *
from lib.MQTT_Broker import *
from lib.Nfc import *
from lib.Order_interface import *

func = None
nfc_obj = None


def start_thread(func):
    global nfc_obj
    t = threading.Thread(target=func, daemon=True)
    t.start()
    return t



#version 11.07.2024
#Bugs corrected:
#    - Block screenshoot blocked when ordered requested at same time that NFC read solved.

#version 05.06.2024
#Bugs corrected:
#    - "WAITING FOR ORDER" is the only status that allow orders in TXT4 Menu


display.set_attr("txt_label_version.text", str('Version 2024/07/11'))
ini_stocks()
initlib_log(2)
nfc_obj = nfc_init()
mosquitto_restart()
init_config_MQTT()
ini_bridge()
threads_info = [
    {"func": thread_ftCloud, "thread": None},
    {"func": bridge_Monitoring, "thread": None},
    {"func": thread_Local, "thread": None},
    {"func": tr_Order_Status ,"thread":None},
    {"func": thread_display_update ,"thread":None}
]

for info in threads_info:
    info["thread"] = start_thread(info["func"])
start_publish_threads()
while True:
    #watchdog
        for info in threads_info:
            if not info["thread"].is_alive():
                logging.warning("Thread {} died. Restarting...".format(info['func'].__name__))
                info["thread"] = start_thread(info["func"])
        time.sleep(2)
