import logging
import threading
import time
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from fischertechnik.mqtt.FTCloudClient import FTCloudClient
from fischertechnik.mqtt.MqttClient import MqttClient
from lib.display import *
from lib.display_update import *
from lib.Factory_Variables import *
from lib.MQTT_Subscriber import *
from lib.Nfc_MQTT import *
from lib.SSC_Publisher import *

_tr0 = None
_tr = None
_dg = None
func = None
threads_info = None
client_local = None
is_cloud_connected = None
last_movement_alarm = None
last_temperature_alarm = None
last_humidity_alarm = None
def connectLocal():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    client_local = MqttClient()
    set_client_local(client_local)
    for count in range(10):
        logging.log(logging.DEBUG_FCL, 'connecting local ...')
        client_local.connect(host='localhost', port=1883, user='', password='')
        if client_local.is_connected():
            publish_broadcast('init')
            client_local.subscribe(topic='o/broadcast', callback=mqtt_callback_broadcast, qos=2)
            client_local.subscribe(topic='f/o/nfc/ds', callback=mqtt_callback_nfc, qos=2)
            client_local.subscribe(topic='fl/o/nfc/ds', callback=mqtt_callback_nfc_local, qos=2)
            threading.Thread(target=thread_nfc_process_cmd_local, daemon=True).start()
            set_node_red_status(True)
            publish_config_local()
            break
        time.sleep(1)



def initlog_FCL(_tr0, _tr, _dg):
    global func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.TRACE0_FCL = _tr0
    logging.addLevelName(logging.TRACE0_FCL , 'TRACE0_FCL')
    logging.TRACE_FCL = _tr
    logging.addLevelName(logging.TRACE_FCL , 'TRACE_FCL')
    logging.DEBUG_FCL = _dg
    logging.addLevelName(logging.DEBUG_FCL, 'DEBUG_FCL')


def get_client_local():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    return client_local


def on_txt_switch_cam_toggled(event):
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    if bool(event['checked']):
        camera_enable()
    else:
        camera_disable()


def connectCloud_function():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    is_cloud_connected = False
    for count2 in range(10):
        logging.log(logging.DEBUG_FCL, 'connecting cloud ...')
        try:
            FTCloudClient.getInstance().connect()
        except Exception as e:
            logging.error("Problems by connecting to fischertechnik Cloud")
            logging.error(e)

        if FTCloudClient.getInstance().is_connected():
            logging.log(logging.DEBUG_FCL, 'cloud connected')
            is_cloud_connected = True
            #Reset view on connect
            publish_Nfc_Data(True)
            threading.Thread(target=thread_nfc_process_cmd, daemon=True).start()
            set_cloud_active(True)
            break
        time.sleep(1)


def thread_ftCloud():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    connectCloud()
    camera_image = []
    last_movement_alarm = 0
    last_temperature_alarm = 0
    last_humidity_alarm = 0
    publish_broadcast('init')
    while True:
        if not (FTCloudClient.getInstance().is_connected()):
            logging.warning("Connection to cloud lost")
            if (get_cloud_active()) == True:
                if time.time() - (get_keep_alive()) >= 300:
                    logging.debug("Decreasing frequence camera")
                    decrease_frequency_MQTT()
                    set_cloud_active(False)
            time.sleep(10)
            connectCloud()
        else:
            set_cloud_active(True)
        time.sleep(30)


def connectCloud():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    try:
        connectCloud_function()
    except Exception as e:
        logging.error("Problems connecting to fischertechnik Cloud")
        logging.error(e)


def thread_Local():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    connectLocal()
    while client_local.is_connected():
        pass
    set_node_red_status(False)


def start_publish_threads():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    #your python code

    threading.Thread(target=publish_bme680, daemon=True).start()
    threading.Thread(target=publish_ldr, daemon=True).start()
    threading.Thread(target=publish_camera, daemon=True).start()

    threads_info = [
        {"func": publish_bme680, "thread": None},
        {"func": publish_ldr, "thread": None},
        {"func": publish_camera, "thread": None},
    ]

    for info in threads_info:
        info["thread"] = start_thread(info["func"])

    watchdog_thread = threading.Thread(target=watchdog, args=(threads_info,), daemon=True)
    watchdog_thread.start()


def start_thread(func):
    global _tr0, _tr, _dg, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    t = threading.Thread(target=func, daemon=True)
    t.start()
    return t



def watchdog(threads_info):
    global _tr0, _tr, _dg, func, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    while True:
            for info in threads_info:
                if not info["thread"].is_alive():
                    logging.warning("Thread {} died. Restarting...".format(info['func'].__name__))
                    info["thread"] = start_thread(info["func"])
            time.sleep(2)


def init_config_MQTT():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    camera_enable()
    set_ldr_period(60)
    set_bme680_period(60)
    set_camera_fps(1)
    set_camera_on(True)
    set_alarm_timer(5)
    set_init_finished(True)


def decrease_frequency_MQTT():
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    print('decrease_frequency_MQTT')
    set_ldr_period(60)
    set_bme680_period(60)
    set_camera_fps(1)
    set_camera_on(False)


def mqtt_callback(message):
    global _tr0, _tr, _dg, func, threads_info, client_local, is_cloud_connected, last_movement_alarm, last_temperature_alarm, last_humidity_alarm
    logging.log(logging.TRACE_FCL, '-')
    if (get_init_finished()) and not not len(message.payload.decode("utf-8")):
        msg= json.loads(message.payload.decode("utf-8"))
        ts = msg["ts"]
        print(ts)



display.switch_toggled("txt_switch_cam", on_txt_switch_cam_toggled)

FTCloudClient.getInstance().subscribe("/j1/txt/" + str(CONTROLLER_ID) + "/f/o/state/ack", mqtt_callback)


