import logging
import subprocess
import time
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from fischertechnik.mqtt.FTCloudClient import FTCloudClient
from fischertechnik.mqtt.MqttClient import MqttClient
from lib.display_update import *
from lib.Factory_Variables import *

bridge_client = None
line_link = None
def ini_bridge_inTry():
    global bridge_client, line_link
    bridge_client = MqttClient()
    for count in range(10):
        bridge_client.connect(host='localhost', port=1883, user='', password='')
        if bridge_client.is_connected():
            bridge_client.subscribe(topic='f/i/#', callback=mqtt_callback_bridge, qos=0)
            bridge_client.subscribe(topic='i/ldr', callback=mqtt_callback_bridge, qos=0)
            bridge_client.subscribe(topic='i/bme680', callback=mqtt_callback_bridge, qos=0)
            bridge_client.subscribe(topic='i/broadcast', callback=mqtt_callback_bridge, qos=0)
            bridge_client.subscribe(topic='i/ptu/#', callback=mqtt_callback_bridge, qos=0)
            bridge_client.subscribe(topic='fl/#', callback=mqtt_callback_bridge, qos=0)
            set_bridge_status(True)
            break
        time.sleep(1)



def check_cloud_connect():
    global bridge_client, line_link
    #/usr/sbin/iw dev mlan0 link
    try:
        proc = subprocess.Popen(['/usr/sbin/iw','dev', 'mlan0', 'link'],stdout=subprocess.PIPE)
    except Exception as e:
        logging.error("Problems obtining Wifi information")
        logging.error(e)
    line_link = proc.stdout.readline().decode()
    #if not line_link:
    #break
    print(line_link.rstrip('\n'))
    if line_link.find('Connected to ') + 1 > 0:
        set_cloud_status(True)
    else:
        set_cloud_status(False)


def mqtt_callback_bridge(message):
    global bridge_client, line_link
    if get_cloud_active():
        logging.debug("Bridge")
        logging.debug(message.payload.decode('utf-8'))
        try:

            topic = "/j1/txt/" + str(CONTROLLER_ID) +"/" + message.topic
            FTCloudClient.getInstance().publish(topic, message.payload)

        except Exception as e:
            logging.error("Problem processing  and publishing the message.the message")
            logging.error(e)



def mqtt_callback(message):
    global bridge_client, line_link
    try:
        print('Cloud Message received')
        print(message.topic)
        print(message.payload.decode("utf-8"))
        bridge_client.publish(topic='o/ptu', payload=message.payload.decode("utf-8"), qos=0, retain=False)
    except Exception as e:
        logging.error("Problems receiving ptu message")
        logging.error(e)



def mqtt_callback2(message):
    global bridge_client, line_link
    try:
        print('Cloud Message received')
        print(message.topic)
        print(message.payload.decode("utf-8"))
        bridge_client.publish(topic='f/o/order', payload=message.payload.decode("utf-8"), qos=0, retain=False)
    except Exception as e:
        logging.error("Problems receiving message from cloud")
        logging.error(e)



def ini_bridge():
    global bridge_client, line_link
    try:
        ini_bridge_inTry()
    except Exception as e:
        logging.error("Problems inizializing Bridge")
        logging.error(e)


def bridge_Monitoring():
    global bridge_client, line_link
    while True:
        if not (bridge_client.is_connected()):
            set_bridge_status(False)
            ini_bridge()
            logging.info("Connection from Bridge to MQTT Local lost... ")
        check_cloud_connect()
        time.sleep(60)


FTCloudClient.getInstance().subscribe("/j1/txt/" + str(CONTROLLER_ID) + "/o/ptu", mqtt_callback)
FTCloudClient.getInstance().subscribe("/j1/txt/" + str(CONTROLLER_ID) + "/f/o/order", mqtt_callback2)


