import logging
import subprocess
import threading
from lib.display_update import *
from lib.MQTT_Broker import *

_tr0 = None
_tr = None
_dg = None
pid = None
def mosquitto_stop():
    global _tr0, _tr, _dg, pid
    logging.debug("mosquitto_stop")
    #process.terminate()
    if pid != None:
        bashCommand = "kill -9 " + str(pid)
        #print(bashCommand)
        process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
        output, error = process.communicate()
        print("  stop (output, error): ", output, error)
        stdout_list = str(output)[2:].split("\\n")
        print("  stop (stdout_list): ", stdout_list)
        pid = mosquitto_status_pid()
        print('mosquitto: pid {} stopped'.format(pid))
        pid = None
    else:
        print('mosquitto: no pid found, already stopped')
    print('status pid: {}'.format(mosquitto_status_pid()))



def initlog_MQTT(_tr0, _tr, _dg):
    global pid
    logging.TRACE0_MQTT = _tr0
    logging.addLevelName(logging.TRACE0_MQTT , 'TRACE0_MQTT')
    logging.TRACE_MQTT = _tr
    logging.addLevelName(logging.TRACE_MQTT , 'TRACE_MQTT')
    logging.DEBUG_MQTT = _dg
    logging.addLevelName(logging.DEBUG_MQTT, 'DEBUG_MQTT')


def mosquitto_status_pid():
    global _tr0, _tr, _dg, pid
    logging.debug("mosquitto_status_pid")
    #print("ps | grep mosquitto")
    bashCommand = "ps"
    ps = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
    bashCommand = "grep mosquitto"
    grep = subprocess.Popen(bashCommand.split(), stdin=ps.stdout, stdout=subprocess.PIPE)
    ps.stdout.close()
    output, error = grep.communicate()
    stdout_list = str(output)[2:-1].split("\\n")
    logging.debug(stdout_list)
    for i in stdout_list:
        #print(i)
        i_list = i.split()
        if len(i_list) >= 5 and i_list[1] == 'ftgui' and i_list[4]=='/usr/sbin/mosquitto':
            #print(i_list)
            pid = int(i_list[0])
    if pid == None:
        print("  no pid found")
    else:
        #print("  pid: ",pid)
        pass
    if pid == None:
        set_broker_status(False)
    else:
        set_broker_status(True)
    return pid


def mosquitto_start():
    global _tr0, _tr, _dg, pid
    logging.debug("mosquitto_start")
    if pid == None:
        print('mosquitto: pid {} started'.format(pid))
        threading.Thread(target=thread_mosquitto, daemon=True).start()
    else:
        print('mosquitto: pid {} found, already started'.format(pid))
    print('status pid: {}'.format(mosquitto_status_pid()))


def thread_mosquitto():
    global _tr0, _tr, _dg, pid
    bashCommand = "/usr/sbin/mosquitto --port 1883"
    #print(bashCommand)
    process = subprocess.Popen(bashCommand.split(), stdout=subprocess.PIPE)
    output, error = process.communicate()
    print("  start (output, error): ", output, error)
    stdout_list = str(output)[2:].split("\\n")
    print("  start (stdout_list): ", stdout_list)


def mosquitto_restart():
    global _tr0, _tr, _dg, pid
    mosquitto_stop()
    mosquitto_start()


