import logging
import time
from fischertechnik.mqtt.MqttClient import MqttClient
from lib.display_update import *
from lib.Factory_Variables import *
from lib.Nfc import *
from lib.Nfc_MQTT import *
from lib.Sound import *
from lib.SSC_Publisher import *

cmd = None
mask = None
cmdNfc = None
res = None
count_write = None
keep_alive_timestamp = None
h = None
index = None
ts = None
i = None
_state = None
msgk = None
bit = None
wp_state = None
_type = None
_mask = None
wp_type = None
_vts = None
data = None
def mqtt_callback_nfc_local(message):
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    msg = json.loads(message.payload.decode("utf-8"))
    logging.debug(msg)
    tsstr = msg["ts"]
    #print(tsstr)
    ts = datetime.strptime(tsstr[:-1], "%Y-%m-%dT%H:%M:%S.%f").replace(tzinfo=timezone.utc).timestamp()
    #print(ts)
    cmd = msg["cmd"]
    #print(cmd)
    wp = None
    h = None
    try:
        wp = msg["workpiece"]
        wp_id = wp["id"]
        wp_type = wp["type"]
        wp_state = wp["state"]
        h_json = msg["history"]
        h = [None]*8
        for h_i in h_json:
            h_i_ts = h_i["ts"]
            h_i_code = int(h_i["code"])
            idx = int((h_i_code/100)-1)
            print(h_i_ts, h_i_code, idx)
            if idx>=0 and idx<=7:
                ts_i = datetime.strptime(h_i_ts[:-1], "%Y-%m-%dT%H:%M:%S.%f").replace(tzinfo=timezone.utc).timestamp()
                print( ts_i)
                h[idx] = ts_i
        print("wp", wp)
        print("h", h)
    except Exception as e:
        pass
    if time.time() - ts < 60:
        if cmd == 'read_uid' or cmd == 'read' or cmd == 'delete' or cmd == 'write':
            logging.log(logging.DEBUG_FCL, cmd)
            reqNfc(cmd)


def thread_nfc_process_cmd_local():
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    while True:
        if cmdNfc == 'read_uid':
            logging.log(logging.TRACE_FCL, "read_uid")
            res = nfc_read_uid()
            if res != None:
                beep_blocked()
                set_line1('<h3>local: NFC read_uid</h3>')
                set_line2('<h3>{}</h3>'.format(res))
                set_line3('')
                publish_Nfc_Data(False)
            cmdNfc = None
        elif cmdNfc == 'read':
            logging.log(logging.TRACE_FCL, "read")
            res = nfc_read()
            if res != None:
                beep_blocked()
                set_line1('<h3>local: NFC read</h3>')
                set_line2('<h3>{}, {}</h3>'.format(get_nfc_data_uid(), get_nfc_data_type_str()))
                set_line3('')
                publish_Nfc_Data(False)
            cmdNfc = None
        elif cmdNfc == 'delete':
            logging.log(logging.TRACE_FCL, "delete")
            res = nfc_read_uid()
            if res != None:
                res = nfc_delete()
                if res != None:
                    beep_blocked()
                    set_line1('<h3>local: NFC delete</h3>')
                    set_line2('<h3>{}</h3>'.format(get_nfc_data_uid()))
                    set_line3('')
                    publish_Nfc_Data(False)
            cmdNfc = None
        elif cmdNfc == 'write':
            logging.log(logging.TRACE_FCL, "write")
            res = nfc_read_uid()
            if res != None:
                res = nfc_write_history()
                if res != None:
                    beep_blocked()
                    set_line1('<h3>local: NFC write</h3>')
                    set_line2('<h3>{}, {}, {}</h3>'.format(get_nfc_data_uid(), (get_nfc_data_type_str()).upper(), (get_nfc_data_state_str()).upper()))
                    set_line3('dur(s): {}'.format(get_nfc_data_ts_list_diff()))
                    publish_Nfc_Data(False)
            cmdNfc = None
        elif cmdNfc == None:
            pass
        else:
            set_line1('<h3>local: NFC unknown cmd: {}</h3>'.format(cmdNfc))
            set_line2('')
            set_line3('')
        time.sleep(0.25)



def mqtt_callback_broadcast(message):
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    set_cloud_active(True)
    if keep_alive_timestamp == None:
        logging.log(logging.DEBUG_FCL, 'set keep alive value')
        set_keep_alive(time.time())
    if (get_init_finished()) and not not len(message.payload.decode("utf-8")):
        try:
            msg= json.loads(message.payload.decode("utf-8"))
            #print(msg)
            last_msg = msg["ts"]
            msgk = msg["message"]
        except Exception as e:
            logging.error("Problems in the mqtt_local_callback_broadcast receiving message")
            logging.error(e)
        if msgk == 'keep-alive':
            set_keep_alive(to_datetime_utc(last_msg).timestamp())
            publish_broadcast('keep-alive')



def mqtt_callback_nfc(message):
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    try:
        msg = json.loads(message.payload.decode("utf-8"))
        print(msg)
        tsstr = msg["ts"]
        #print(tsstr)
        ts = datetime.strptime(tsstr[:-1], "%Y-%m-%dT%H:%M:%S.%f").replace(tzinfo=timezone.utc).timestamp()
        #print(ts)
        cmd = msg["cmd"]
        #print(cmd)
    except Exception as e:
        logging.error(" mqtt_callback_nfc Problems receiving NFC  message ")
        logging.error(e)



def map_get_msk():
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    mask = 0
    if h != None:
        print("h: ", h)
        index = 0
        for i in h:
            #print("i: ", i)
            bit = bin(1 if i != None else 0)
            #print("bit: ", bit)
            if bit == bin(1):
                mask += 2 ** index
            #print("mask: ", mask)
            index = (index if isinstance(index, (int, float)) else 0) + 1
    print("map_get_msk: ", mask)
    return mask


def reqNfc(cmd):
    global mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, cmd)
    cmdNfc = cmd


def getLastCmdNfc():
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    return cmdNfc


def nfc_write_history():
    global cmd, mask, cmdNfc, res, count_write, keep_alive_timestamp, h, index, ts, i, _state, msgk, bit, wp_state, _type, _mask, wp_type, _vts, data
    logging.log(logging.TRACE_FCL, '-')
    # nfc_data:
    #   0:nfc uid:
    #     workpiece NTAG213:  7 bytes
    #     card + blue key Mifare: 4 bytes
    #   1:byte0: state: 0:RAW, 1:PROCESSED, 2:REJECTED
    #   2:byte1: type: 0:NONE, 1:WHITE, 2:RED, 3:BLUE
    #   3:byte2: mask timestamps
    #   4:byte3: none (reserved)
    #   5:byte4...4+(8*8): vts[8]: int64_t (8 bytes)
    res = False
    count_write = 0
    while True:
        if wp_state == 'RAW':
            _state = 0
        elif wp_state == 'PROCESSED':
            _state = 1
        elif wp_state == 'REJECTED':
            _state = 2
        else:
            _state = 255
        if wp_type == 'WHITE':
            _type = 1
        elif wp_type == 'RED':
            _type = 2
        elif wp_type == 'BLUE':
            _type = 3
        else:
            _type = 0
        _mask = map_get_msk()
        _vts = h
        #print("_state", _state)
        #print("_type", _type)
        #print("_mask", _mask)
        #print("_vts", _vts)
        res = nfc_write(_state, _type, _mask, _vts)
        #HINT: res=nfc_write is always false
        data = nfc_read()
        #print(data)
        res = (get_nfc_data_state()) == _state and (get_nfc_data_type()) == _type and (get_nfc_data_mask()) == _mask
        print("res: ", res)
        count_write = (count_write if isinstance(count_write, (int, float)) else 0) + 1
        if res or count_write >= 3:
            break
        else:
            print(data)
        time.sleep(1)
    return res


