import json
import logging
import time
from fischertechnik.mqtt.Constants import CONTROLLER_ID
from fischertechnik.mqtt.FTCloudClient import FTCloudClient
from fischertechnik.mqtt.MqttClient import MqttClient
from lib.display_update import *
from lib.Factory_Variables import *
from lib.Nfc import *
from lib.Sound import *
from lib.Time import *

nfc_remote = None
cmd = None
cmdNfc = None
nfc_data_uid = None
nfc_data_type_str = None
nfc_data_state_str = None
nfc_data_mask_str = None
res = None
ts = None
history = None
list_tsstr = None
payload = None
workpiece = None
i = None
history_item = None
def publish_Nfc_Data(nfc_remote):
    global cmd, cmdNfc, nfc_data_uid, nfc_data_type_str, nfc_data_state_str, nfc_data_mask_str, res, ts, history, list_tsstr, payload, workpiece, i, history_item
    logging.log(logging.TRACE_FCL, '-')
    nfc_data_uid = get_nfc_data_uid()
    nfc_data_type_str = (get_nfc_data_type_str()).upper()
    nfc_data_state_str = (get_nfc_data_state_str()).upper()
    nfc_data_mask_str = get_nfc_data_mask_str()
    workpiece =  {
         "id": nfc_data_uid if (nfc_data_uid!=None) else "" ,
         "type": nfc_data_type_str,
         "state": nfc_data_state_str
    }
    logging.log(logging.DEBUG_FCL, workpiece)
    logging.log(logging.DEBUG_FCL, nfc_data_mask_str)
    if is_nfc_data_ts_list_valid():
        history = []
        list_tsstr = get_nfc_data_tsstr_list()
        if list_tsstr != None:
            print("list_tsstr: ", list_tsstr)
            logging.log(logging.DEBUG_FCL, list_tsstr)
            i_end = len(list_tsstr)
            for i in (1 <= i_end) and upRange(1, i_end, 1) or downRange(1, i_end, 1):
                print("i: ", i, nfc_data_mask_str, list_tsstr)
                logging.log(logging.DEBUG_FCL, nfc_data_mask_str)
                if nfc_data_mask_str != None and 8 - i < len(nfc_data_mask_str):
                    if nfc_data_mask_str[int((9 - i) - 1)] == '1':
                        if i < len(list_tsstr):
                            pass
                        history_item = {
                           "ts": list_tsstr[i-1],
                           "code": i*100
                        }
                        print("ADD item: ", history_item)
                        history.append(history_item)
    else:
        history = None
    print("history ", history)
    payload = '{{"ts":"{}", "workpiece":{}, "history":{} }}'.format(timestamp_utcnow(), workpiece, history)
    #print(payload)
    payload = json.dumps(eval(payload))
    print(payload)
    logging.log(logging.DEBUG_FCL, payload)
    if nfc_remote:
        logging.log(logging.DEBUG_FCL, "publish remote")
        if get_cloud_active():
            FTCloudClient.getInstance().publish("/j1/txt/" + str(CONTROLLER_ID) +"/f/i/nfc/ds", payload)
    else:
        logging.log(logging.DEBUG_FCL, "publish local")
        if get_client_local().is_connected():
            get_client_local().publish(topic='fl/i/nfc/ds', payload=payload, qos=2, retain=False)

def thread_nfc_process_cmd():
    global nfc_remote, cmd, cmdNfc, nfc_data_uid, nfc_data_type_str, nfc_data_state_str, nfc_data_mask_str, res, ts, history, list_tsstr, payload, workpiece, i, history_item
    logging.log(logging.TRACE_FCL, '-')
    while True:
        if cmdNfc == 'read_uid':
            logging.log(logging.TRACE_FCL, "read_uid")
            res = nfc_read_uid()
            if res != None:
                beep_blocked()
                set_line1('<h3>cloud: NFC read_uid</h3>')
                set_line2('<h3>{}</h3>'.format(res))
                publish_Nfc_Data(True)
            cmdNfc = None
        elif cmdNfc == 'read':
            logging.log(logging.TRACE_FCL, "read")
            res = nfc_read()
            if res != None:
                beep_blocked()
                set_line1('<h3>cloud: NFC read</h3>')
                set_line2('<h3>{}, {}</h3>'.format(get_nfc_data_uid(), get_nfc_data_type_str()))
                publish_Nfc_Data(True)
            cmdNfc = None
        elif cmdNfc == 'delete':
            logging.log(logging.TRACE_FCL, "delete")
            res = nfc_delete()
            if res != None:
                beep_blocked()
                set_line1('<h3>cloud: NFC delete</h3>')
                set_line2('<h3>{}</h3>'.format(get_nfc_data_uid()))
                publish_Nfc_Data(True)
            cmdNfc = None
        elif cmdNfc == None:
            pass
        else:
            set_line1('<h3>cloud: NFC unknown cmd: {}</h3>'.format(cmdNfc))
            set_line2('')
        time.sleep(0.25)



def reqNfc(cmd):
    global nfc_remote, cmdNfc, nfc_data_uid, nfc_data_type_str, nfc_data_state_str, nfc_data_mask_str, res, ts, history, list_tsstr, payload, workpiece, i, history_item
    logging.log(logging.TRACE_FCL, cmd)
    cmdNfc = cmd


def getLastCmdNfc():
    global nfc_remote, cmd, cmdNfc, nfc_data_uid, nfc_data_type_str, nfc_data_state_str, nfc_data_mask_str, res, ts, history, list_tsstr, payload, workpiece, i, history_item
    logging.log(logging.TRACE_FCL, '-')
    return cmdNfc


def mqtt_callback(message):
    global nfc_remote, cmd, cmdNfc, nfc_data_uid, nfc_data_type_str, nfc_data_state_str, nfc_data_mask_str, res, ts, history, list_tsstr, payload, workpiece, i, history_item
    logging.log(logging.TRACE_FCL, '-')
    if (get_init_finished()) and not not len(message.payload.decode("utf-8")):
        msg= json.loads(message.payload.decode("utf-8"))
        print(msg)
        tsstr = msg["ts"]
        #print(tsstr)
        ts = datetime.strptime(tsstr[:-1], "%Y-%m-%dT%H:%M:%S.%f").replace(tzinfo=timezone.utc).timestamp()
        #print(ts)
        cmd = msg["cmd"]
        #print(cmd)
        if time.time() - ts < 60:
            logging.log(logging.DEBUG_FCL, '-')
            if cmd == 'read_uid' or cmd == 'read' or cmd == 'delete':
                logging.log(logging.DEBUG_FCL, cmd)
                reqNfc(cmd)



FTCloudClient.getInstance().subscribe("/j1/txt/" + str(CONTROLLER_ID) + "/f/o/nfc/ds", mqtt_callback)

def upRange(start, stop, step):
    while start <= stop:
        yield start
        start += abs(step)
def downRange(start, stop, step):
    while start >= stop:
        yield start
        start -= abs(step)

