import json
import logging
import time
from fischertechnik.mqtt.MqttClient import MqttClient
from lib.display import *
from lib.display_update import *
from lib.Factory_Variables import *
from lib.Time import *

COLOR = None
j = None
payload_order = None
fabric_ready = None
k = None
colors = None
n = None
msg_status = None
order_client = None
i = None
stockItems = None
workpiece = None
c = None
def Order_status_ini():
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    fabric_ready = True
    colors = ['WHITE', 'RED', 'BLUE']
    logging.info("Interface orders initializing... ")
    order_client = MqttClient()
    for count in range(10):
        order_client.connect(host='localhost', port=1883, user='', password='')
        if order_client.is_connected():
            order_client.subscribe(topic='f/i/stock', callback=mqtt_callback_order_stock, qos=0)
            order_client.subscribe(topic='f/i/order', callback=mqtt_callback_order_status, qos=0)
            logging.info("Order interface client connected..")
            break
        time.sleep(1)



def mqtt_callback_order_status(message):
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    try:
       # print(str(message.payload))
        data = json.loads(message.payload.decode('utf-8'))
        msg_status = data["state"]
        #print(stockItems)
    except Exception as e:
        logging.error(e)
    print(msg_status)
    if msg_status == 'WAITING_FOR_ORDER':
        logging.info("Ready for order ")
        #print("Ready for process")
        fabric_ready = True
    else:
        logging.info("Order in process")
        #print("Order in process")
        fabric_ready = False



def on_txt_order_white_clicked(event):
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    Order('WHITE')


def on_txt_order_red_clicked(event):
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    Order('RED')


def on_txt_order_blue_clicked(event):
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    Order('BLUE')


def stocks_update():
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    for j in colors:
        n = get_stock(j)
        if 'WHITE' == j:
            set_lb_stock_white(n)
            if n > 0:
                set_white_piece_status(True)
                if fabric_ready:
                    set_order_white(True)
            else:
                set_white_piece_status(False)
                set_order_white(False)
        elif 'RED' == j:
            set_lb_stock_red(n)
            if n > 0:
                set_red_piece_status(True)
                if fabric_ready:
                    set_order_red(True)
            else:
                set_red_piece_status(False)
                set_order_red(False)
        else:
            set_lb_stock_blau(n)
            if n > 0:
                set_blue_piece_status(True)
                if fabric_ready:
                    set_order_blue(True)
            else:
                set_blue_piece_status(False)
                set_order_blue(False)
    if not fabric_ready:
        set_order_blue(False)
        set_order_red(False)
        set_order_white(False)


def Order(COLOR):
    global j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    payload_order = '{{"type":"{}","ts":"{}"}}'.format(COLOR, timestamp_utcnow())
    order_client.publish(topic='f/o/order', payload=payload_order, qos=0, retain=False)
    logging.info("Ordered by Menu, color: " + COLOR )
    print("Ordered by Menu, color: " + COLOR )


def mqtt_callback_order_stock(message):
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    for k in colors:
        set_stocks(k, 0)
    try:
        #[{'workpiece': {'id': '043279ca341290', 'state': 'RAW', 'type': 'WHITE'}, 'location': 'A1'}, {'workpiece': {'id': '040f7aca341290', 'state': 'RAW', 'type': 'RED'}, 'location': 'A2'}, {'workpiece': {'id': '0', 'state': '', 'type': ''}, 'location': 'A3'}, {'workpiece': {'id': '04a879ca341290', 'state': 'RAW', 'type': 'RED'}, 'location': 'B1'}, {'workpiece': {'id': '049079ca341290', 'state': 'RAW', 'type': 'RED'}, 'location': 'B2'}, {'workpiece': {'id': '0', 'state': '', 'type': ''}, 'location': 'B3'}, {'workpiece': {'id': '046179ca341290', 'state': 'RAW', 'type': 'RED'}, 'location': 'C1'}, {'workpiece': {'id': '041c79ca341290', 'state': 'RAW', 'type': 'WHITE'}, 'location': 'C2'}, {'workpiece': {'id': '0', 'state': '', 'type': ''}, 'location': 'C3'}]
        #print(str(message.payload))
        data = json.loads(message.payload.decode('utf-8'))
        #msg= json.loads(str(message.payload))
        stockItems = data["stockItems"]
        #print(stockItems)
    except Exception as e:
        logging.error(e)
    for i in stockItems:
        workpiece = i['workpiece']
        if not not len(workpiece):
            c = workpiece['type']
            if c != '':
                increase_stocks(c)
    stocks_update()



def tr_Order_Status():
    global COLOR, j, payload_order, fabric_ready, k, colors, n, msg_status, order_client, i, stockItems, workpiece, c
    Order_status_ini()
    while True:
        if not (order_client.is_connected()):
            logging.info("Order interface client not connected.")
        time.sleep(5)


display.button_clicked("txt_order_white", on_txt_order_white_clicked)
display.button_clicked("txt_order_red", on_txt_order_red_clicked)
display.button_clicked("txt_order_blue", on_txt_order_blue_clicked)


